/*
 * Java
 *
 * 2013-2022 ESR - Not subject to Copyright.
 *
 * This document has been released and published by E-S-R consortium, a non-profit entity.
 * To learn more about E-S-R consortium, please visit http://www.e-s-r.net/.
 * The matter contained in this document is not subject to copyright; you are free to use it for any purpose, for more information see E-S-R consortium policies.
 */
package ej.kf;

/**
 * Handler for uncaught exceptions thrown in a Feature.
 *
 * @deprecated Use {@link java.lang.Thread.UncaughtExceptionHandler}
 */
@Deprecated
public interface UncaughtExceptionHandler {

	/**
	 * Method invoked when the given thread terminates due to the given uncaught
	 * exception.
	 * <p>
	 * Any exception thrown by this method will be ignored by the Java Virtual
	 * Machine.
	 * 
	 * @param f
	 *            the feature
	 * @param t
	 *            the thread
	 * @param e
	 *            the exception
	 */
	public void uncaughtException(Feature f, Thread t, Throwable e);

}
